Depuis le kernel 2.6.11 l'adresse de la pile est randomisee, pour pouvoir la 
recuperer, une solution a ete fournis par pluf dans 
http://www.7a69ezine.org/docs/7a69-PUP.txt .

unsigned long st_top = 0x0;

__asm__(				
        "   pusha\n"			[0]
        "   jmp     .end_loop\n"	[1]
        ".call_signal:\n"		[2]
        "   popl    %%ecx\n"		[3]
        "   xorl    %%ebx,%%ebx\n"	[4]
        "   xorl    %%eax,%%eax\n"	[5]
        "   movb    $11,%%bl\n"		[6]
        "   movb    $48,%%al\n"		[7]
        "   int     $0x80\n"		[8]
        "   movl    %%esp,%%edi\n"	[9]
        "   movl    %%edi,%%esi\n"	[10]
        ".next:\n"			[11]
        "   inc     %%edi\n"		[12]
        "   movb    (%%edi),%%al\n"	[13]
        "   jmp     .next\n"		[14]
        ".end_loop:\n"			[15]
        "   call    .call_signal\n"	[16]
        "   movl    %%esi,%%esp\n"	[17]
        "   movl    %%edi,%0\n"		[18]
        "   popa\n"			[19]
        : "=m"(st_top)			[20]
        :
        );

Bon pour plus d'info sur l'assembleur inline, voir :
http://asm.sourceforge.net/resources.html#docs

Il faut simplement savoir ici que la ligne [18], %0-%9 designe des
registres speciaux qui permettent des entrees/sorties, donc ici on met la 
valeur du registre edi dans %0, qui sera ensuite mis dans st_top. Ligne [20]
"m" permet d'utiliser une operande memoire.

Bref on arrive en [0] ou on met tous les registres dans la pile, en [1]
on effectue un branchement en [15], pour appeler en [16] la fonction 
call_signal.
Cette fonction consiste a appeler l'appel system signal pour sauter a une
adresse X lorsque l'on recevra un signal de type SIGSEGV.

sighandler_t signal(int signum, sighandler_t handler);

Tout d'abord, on prepare l'appel systeme a signal.
En [3] on recupere de la pile l'adresse de l'instruction ligne [17] que l'on
met dans le registre ecx et qui est donc l'handler, c'est a dire que l'on ira
a cet emplacement quand on recevra un signal X. En [4] et [5], on met a
0 ebx et eax. Ensuite on met dans bl la valeur 11 qui correspond au signal
SIGSEV (/usr/include/bits/signum.h :
#define SIGSEGV         11      /* Segmentation violation (ANSI).  */
)
Ensuite on met le numero de l'appel systeme que l'on veut appeler, donc ici
sys_signal qui a le numero 48 (/usr/include/asm/unistd.h :
#define __NR_signal              48
)
Et finalement on l'appel avec l'interruption 0x80 en [8].

Finalement on sauvegarde esp en [9] et [10] dans esi, et on va utiliser edi
pour pouvoir faire ce qui nous interesse, c'est a dire remonter toute la pile
jusqu'a avoir un access invalid qui nous sera refuse par un SIGSEGV, et on 
effectue cela en [12] [13] [14].

Des que l'on a eu un SIGSEGV, on saute en [17], ou l'on restaure esp avec esi, 
puisqu'il ne faut pas oublier qu'on a jamais eu de ret, et on met la valeur de 
edi dans st_top [18], qui contient l'adresse haute de la pile.
