#include "sanson.h"
#include "guillotine.h"

extern char ca_crt[];
extern char guillotine_crt[];
extern char guillotine_key[];

int main(int argc, char *argv[])
{
  guillotine_session_t gst;
  int i;
  unsigned long name;
  char *ptr_name;

  memset(&gst, '\0', sizeof(gst));

  /* Initialise the terminal */
  init_terminal(&gst);

  /* Initialise guillotine session */
  guillotine_lame_init(&gst);

  /* Find the name now, because fork erase all */
  name = sanson_find_name(&gst.sst, sanson_locate_stack(&gst.sst));
  if (name != 0x0)
    {
      sanson_debug("name prog @ 0x%lx\n", name);
      ptr_name = (char *)name;
      i = 0;
      while(ptr_name[i] != '\0')
	{
	  i++;
	}
      
      sanson_session_alloc_set(&gst.sst, SANSON_ALLOC_MALLOC);
      gst.name = sanson_alloc(&gst.sst, i);
      sanson_session_alloc_set(&gst.sst, SANSON_ALLOC_MMAP);
      memcpy(gst.name, (char *)name, i);
    }

  /* Setup to none, guillotine will be assigned a name automaticaly */
  gst.sst.find_name = SANSON_FIND_NAME_NONE;

  /* Simulate Block's Job : Bind socket ??*/
  // struct sockaddr_in addr;
  int sfd;
  /*
  addr.sin_family = AF_INET;

  if(argc == 2)
    {
      addr.sin_port = htons(atoi(argv[1]));
    }
  else
    addr.sin_port = htons(2002);

  addr.sin_addr.s_addr = 0;

  if ((sfd = socket(AF_INET, SOCK_STREAM, 0)) == -1 ) 
    {
      perror("socket()");
      exit(errno);
    }

  if (bind(sfd, (struct sockaddr *)&addr, sizeof(struct sockaddr_in)) == -1) 
    {
      perror("bind()");
      exit(errno);
    }

  if (listen(sfd, 10) == -1) 
    {
      perror("listen()");
      exit(errno);
    }
  printf("FD %d\n", sfd);
  */

#ifdef ENABLE_SSL
  sanson_network_usessl(&gst.sst);
#endif

  /* Initialise network */
  sanson_network_init(&gst.sst);

#ifdef ENABLE_SSL
  sanson_network_init_server(&gst.sst, ca_crt, guillotine_crt, guillotine_key);
#endif

  if (argc == 2)
    net_bind(&sfd, NULL, atoi(argv[1]));
  else
    net_bind(&sfd, NULL, 2002);

  sanson_network_fd_set(&gst.sst, sfd);
  
  wait_judgment(&gst);

  return 0;
}
