#include "sanson.h"

int test_get_list(sanson_session_t *sst)
{
  sanson_paquet_t spt;
  
  memset(&spt, '\0', sizeof(sanson_paquet_t));
  sanson_network_recv(sst, &spt, sizeof(sanson_paquet_t), -1);
  
  while(spt.binary != 0)
    {
      sanson_paquet_view(&spt);
      sanson_network_recv(sst, &spt, sizeof(sanson_paquet_t), -1);
    }

  return 0;
}

int main(int argc, char *argv[])
{
  sanson_session_t test;
  struct sockaddr_in cli;
  int fd;

  sanson_session_init(&test);
  sanson_network_init(&test);

  sanson_session_alloc_set(&test, SANSON_ALLOC_MALLOC);
  cli.sin_family = AF_INET;
  cli.sin_port = htons(2002);
  cli.sin_addr.s_addr = inet_addr("127.0.0.1");
  
  if ((fd = socket(AF_INET, SOCK_STREAM, 0)) < 0)
    {
      perror("socket");
      return -1;
    }
  
  if (connect(fd, (struct sockaddr *)&cli, sizeof(struct sockaddr_in)) < 0)
    {
      perror("connect");
      return -1;
    }

  test.fd = fd;

  sanson_network_send_cmd_list(&test, NULL);
  test_get_list(&test);

  sanson_network_send_cmd_exit(&test, NULL);

  sanson_network_close(&test);

  return 0;
}
