#include "sanson.h"
#include "headman.h"

void close_init(void);
void close_cleanup(void);
void close_help(void);
void close_run(headman_t *, char *);

pCommand mod =
{ "close", NULL, SCOPE_SESSION, close_init, close_cleanup, close_run, close_help};

void close_init(void)
{
#if __DEBUG_HEADMAN__
  fprintf(stdout, "-- CLOSE INIT --\n");
#endif
}

void close_cleanup(void)
{
#if __DEBUG_HEADMAN__
  fprintf(stdout, "-- CLOSE CLEANUP --\n");
#endif
}

void close_help(void)
{
  fprintf(stdout, "Close the current session.");
}

void close_run(headman_t *hdm, char *argv)
{
  headman_session_t *session;

  if(hdm->current_session == -1)
    {
      fprintf(stdout, "-- your are not in a session --\n");
    }
  else 
    {
      session = get_current_session(hdm);

      if( connect_tcp(session) < 0 )
	{
	  perror("connect_tcp()");
	  return;
	} 

      if(session->sst.fd != -1)
	{
	  fprintf(stdout, "-- closing the remote connection --\n");
	  sanson_network_send_cmd_exit(&session->sst, NULL);
	}

      fprintf(stdout, "-- closing session number %d --\n", session->id);

      hdm->current_session = -1;
      close(session->sst.fd);
      TAILQ_REMOVE(&hdm->tailq_session_t, session, next);
      free(session);
    }
}
