#include "sanson.h"
#include "headman.h"

void del_init(void);
void del_cleanup(void);
void del_help(void);
void del_run(headman_t *, char *);

pCommand mod =
{ "del", NULL, SCOPE_SESSION, del_init, del_cleanup, del_run, del_help};

void del_init(void)
{
#if __DEBUG_HEADMAN__
  fprintf(stdout, "-- DEL INIT --\n");
#endif
}

void del_cleanup(void)
{
#if __DEBUG_HEADMAN__
  fprintf(stdout, "-- DEL CLEANUP --\n");
#endif
}

void del_help(void)
{
  fprintf(stdout, "Delete a specified binary on the remote host.");
}

void del_run(headman_t *hdm, char *argv)
{
  char cmd[SANSON_SIZE_STRING];
  headman_session_t *session;
  char *arg;
  char *env;

  if(hdm->current_session == -1)
    {
      fprintf(stdout, "-- your are not in a session --\n");
      return;
    }
  
  session = get_current_session(hdm);

  if( connect_tcp(session) < 0 )
    {
      perror("connect_tcp()");
      return;
    } 
  
  if(session->sst.fd == -1)
    {
      fprintf(stdout, "-- your are not connected --\n");
    }
  else 
    {
      if (*argv == '\n' || !*argv)
	{
	  fprintf(stdout, "-- a name is required --\n");
	  return;
	}

      if(sanson_session_paquet_del(&session->sst, argv) != -1)
	{
	  if(sanson_network_send_cmd_del(&session->sst, argv) != -1)
	    {
	      fprintf(stdout, "-- deleting the binary '%s' --\n", argv);
	    }
	}
      else
	fprintf(stdout, "-- this binary doesn't exist --\n");
    }
}
