#include "sanson.h"
#include "headman.h"

void exit_init(void);
void exit_cleanup(void);
void exit_help(void);
void exit_run(headman_t *,char *);

pCommand mod =
{ "exit", NULL, SCOPE_ALL, exit_init, exit_cleanup, exit_run, exit_help};

void exit_init(void)
{
#if __DEBUG_HEADMAN__
  fprintf(stdout, "-- EXIT INIT --\n");
#endif
}

void exit_cleanup(void)
{
#if __DEBUG_HEADMAN__
  fprintf(stdout, "-- EXIT CLEANUP --\n");
#endif
}

void exit_help(void)
{
  fprintf(stdout, "Exit the scope or the program.");
}

void exit_run(headman_t *hdm, char *argv)
{
  if(hdm->current_session != -1) /* in a SCOPE_SESSION */
    {
      hdm->current_session = -1;
      return;
    }
  else
    /* FIXME : Unmap/Free all struct */
    exit(0);
}
