#include "sanson.h"
#include "headman.h"

void help_init(void);
void help_cleanup(void);
void help_help(void);
void help_run(headman_t *, char *);

pCommand mod =
{ "help", NULL, SCOPE_ALL, help_init, help_cleanup, help_run, help_help};

void help_init(void)
{
#if __DEBUG_HEADMAN__
  fprintf(stdout, "-- HELP INIT --\n");
#endif
}

void help_cleanup(void)
{
#if __DEBUG_HEADMAN__
  fprintf(stdout, "-- HELP CLEANUP --\n");
#endif
}

void help_help(void)
{
  fprintf(stdout, "Print this help message.");
}

void help_run(headman_t *hdm, char *argv)
{
  pCommand *current;

  fprintf(stdout, "-- commands available --\n");

  if( hdm->current_session == -1 ) /* it means SCOPE_ALL */
    {
      TAILQ_FOREACH(current, &hdm->tailq_command_t, next) {
	if(current->scope == SCOPE_ALL)
	  {
	    fprintf(stdout, "   %10s - ", current->name);
	    current->help();
	    fprintf(stdout, "\n");
	  }
      }
    }
  else /* it means SCOPE_SESSION */
    {
      TAILQ_FOREACH(current, &hdm->tailq_command_t, next) {
	if(current->scope == SCOPE_SESSION || current->scope == SCOPE_ALL)
	  {
	    fprintf(stdout, "   %10s - ", current->name);
	    current->help();
	    fprintf(stdout, "\n");
	  }
      }
    }
}
