#include "sanson.h"
#include "headman.h"

void kill_init(void);
void kill_cleanup(void);
void kill_help(void);
void kill_run(headman_t *, char *);

pCommand mod =
{ "kill", NULL, SCOPE_SESSION, kill_init, kill_cleanup, kill_run, kill_help};

void kill_init(void)
{
#if __DEBUG_HEADMAN__
  fprintf(stdout, "-- KILL INIT --\n");
#endif
}

void kill_cleanup(void)
{
#if __DEBUG_HEADMAN__
  fprintf(stdout, "-- KILL CLEANUP --\n");
#endif
}

void kill_help(void)
{
  fprintf(stdout, "Kill everything on the remote host (even the guillotine).");
}

void kill_run(headman_t *hdm, char *argv)
{
  headman_session_t *session;

  if(hdm->current_session == -1)
    {
      fprintf(stdout, "-- your are not in a session --\n");
    }
  else 
    {
      session = get_current_session(hdm);

      if( connect_tcp(session) < 0 )
	{
	  perror("connect_tcp()");
	  return;
	} 
      
      if(session->sst.fd != -1)
	{
	  fprintf(stdout, "-- erasing the remote guillotine --\n");
	  sanson_network_send_cmd_killguillotine(&session->sst, NULL);
	}

      fprintf(stdout, "-- closing session number %d --\n", session->id);
      
      hdm->current_session = -1;
      close(session->sst.fd);
      TAILQ_REMOVE(&hdm->tailq_session_t, session, next);
      free(session);
    }
}
