#include "sanson.h"
#include "headman.h"

void list_init(void);
void list_cleanup(void);
void list_help(void);
void list_run(headman_t *, char *);

pCommand mod =
{ "list", NULL, SCOPE_SESSION, list_init, list_cleanup, list_run, list_help};

void list_init(void)
{
#if __DEBUG_HEADMAN__
  fprintf(stdout, "-- LIST INIT --\n");
#endif
}

void list_cleanup(void)
{
#if __DEBUG_HEADMAN__
  fprintf(stdout, "-- LIST CLEANUP --\n");
#endif
}

void list_help(void)
{
  fprintf(stdout, "Show the available binaries.");
}

void list_run(headman_t *hdm, char *argv)
{
  sanson_paquet_t *current_paquet;
  headman_session_t *session;

  if(hdm->current_session == -1)
    {
      fprintf(stdout, "-- your are not in a session --\n");
    }
  else 
    {
      session = get_current_session(hdm);

      if( connect_tcp(session) < 0 )
	{
	  perror("connect_tcp()");
	  return;
	} 

      sanson_network_send_cmd_list(&session->sst, NULL);
      get_paquet_list(&session->sst);

      fprintf(stdout, "-- binaries available --\n");

      for (current_paquet = session->sst.tailq_spt_t.tqh_first; current_paquet != NULL; current_paquet = current_paquet->entries.tqe_next)
	{
	  fprintf(stdout, " * %s\n", current_paquet->spht.name);
	}
    }
}

