#include "sanson.h"
#include "headman.h"

void new_init(void);
void new_cleanup(void);
void new_help(void);
void new_run(headman_t *, char *);

pCommand mod =
{ "new", NULL, SCOPE_ALL, new_init, new_cleanup, new_run, new_help};

void new_init(void)
{
#if __DEBUG_HEADMAN__
  fprintf(stdout, "-- NEW INIT --\n");
#endif
}

void new_cleanup(void)
{
#if __DEBUG_HEADMAN__
  fprintf(stdout, "-- NEW CLEANUP --\n");
#endif
}

void new_help(void)
{
  fprintf(stdout, "Start a new session.");
}

void new_run(headman_t *hdm, char *argv)
{
  headman_session_t *new_session;

  if ((new_session = malloc(sizeof(headman_session_t))) == NULL)
    return;

  headman_session_init(hdm, new_session);

#if __DEBUG_HEADMAN__
      sanson_hexdump_set(&new_session->sst, 16);
#else
      sanson_hexdump_set(&new_session->sst, 0);
#endif

  fprintf(stdout, "-- session %d created --\n", hdm->current_session);
}
