#include "sanson.h"
#include "headman.h"

void option_init(void);
void option_cleanup(void);
void option_help(void);
void option_run(headman_t *, char *);

pCommand mod =
{ "option", NULL, SCOPE_SESSION, option_init, option_cleanup, option_run, option_help};

void option_init(void)
{
#if __DEBUG_HEADMAN__
  fprintf(stdout, "-- OPTION INIT --\n");
#endif
}

void option_cleanup(void)
{
#if __DEBUG_HEADMAN__
  fprintf(stdout, "-- OPTION CLEANUP --\n");
#endif
}

void option_help(void)
{
  fprintf(stdout, "Show the available binaries.");
}

void option_run(headman_t *hdm, char *argv)
{
  sanson_paquet_t *current_paquet;
  headman_session_t *session;
  char cmd[SANSON_SIZE_STRING];
  char option[SANSON_SIZE_STRING];
  char value[SANSON_SIZE_STRING];

  if(hdm->current_session == -1)
    {
      fprintf(stdout, "-- your are not in a session --\n");
    }
  else 
    {
      session = get_current_session(hdm);

      memset(cmd, '\0', SANSON_SIZE_STRING);
      fprintf(stdout, "option: ");
      fflush(NULL);
      fgets(cmd, sizeof(cmd), stdin);
      if(*cmd == '\n' || *cmd == ' ')
	return;
      else
	sscanf(cmd, "%s", option);

      memset(cmd, '\0', SANSON_SIZE_STRING);
      fprintf(stdout, "value: ");
      fflush(NULL);
      fgets(cmd, sizeof(cmd), stdin);
      if(*cmd == '\n' || *cmd == ' ')
	return;
      else
	sscanf(cmd, "%s", value);
  
      fprintf(stdout, "-- sending option %s=%s --\n", option, value);
      
      if( connect_tcp(session) < 0 )
	{
	  perror("connect_tcp()");
	  return;
	} 
      
      if(session->sst.fd == -1)
	{
	  fprintf(stdout, "-- your are not connected --\n");
	  return;
	}

      memset(cmd, '\0', SANSON_SIZE_STRING);
      sprintf(cmd, "%s %s", option, value);
      sanson_network_send_cmd_option(&session->sst, cmd);
    }
}

