#include "sanson.h"
#include "headman.h"

void session_init(void);
void session_cleanup(void);
void session_help(void);
void session_run(headman_t *, char *);

pCommand mod =
{ "session", NULL, SCOPE_ALL, session_init, session_cleanup, session_run, session_help};

void session_init(void)
{
#if __DEBUG_HEADMAN__
  fprintf(stdout, "-- SESSION INIT --\n");
#endif
}

void session_cleanup(void)
{
#if __DEBUG_HEADMAN__
  fprintf(stdout, "-- SESSION CLEANUP --\n");
#endif
}

void session_help(void)
{
  fprintf(stdout, "Switch to another session or show the entire list.");
}

void session_run(headman_t *hdm, char *argv)
{
  headman_session_t *current;
  int int_session;

  if( sscanf(argv, "%d", &int_session) > 0 )
    {
      TAILQ_FOREACH(current, &hdm->tailq_session_t, next) {
	if(current->id == int_session)
       	  {
       	    hdm->current_session = int_session;
       	    return;
       	  }
      }
      
      fprintf(stdout, "-- incorrect session number --\n");
    }
  else
    {
      fprintf(stdout, "-- list of sessions --\n");
      TAILQ_FOREACH(current, &hdm->tailq_session_t, next) {
	if(current->id == hdm->current_session)
	  fprintf(stdout, "=> ");
	else
	  fprintf(stdout, " * ");
	fprintf(stdout, "session %d ", current->id);
	if(current->sst.fd != -1)
	  {
	    fprintf(stdout, "(connected) ");
	    /*
	    if(current->proto == PROTO_IPV6)
	      fprintf(stdout, "(connected with IPv6 from %s:%d to %s:%d) ", current->local_ipv6, current->local_port, current->remote_ipv6, current->remote_port);
	    else
	      fprintf(stdout, "(connected with IPv4 from %s:%d to %s:%d) ", current->local_ipv4, current->local_port, current->remote_ipv4, current->remote_port);
	    */
	  }
	fprintf(stdout, "\n");
      }
    }
}
