#include <asm/unistd.h>

#define _SYS_MMAN_H
#include <bits/mman.h>

/*	
typedef struct s_target
{

  unsigned long addr;
  unsigned long addrl;
  int flags;
  int action;
  unsigned long orig;
  unsigned long origl;

} target_t;
*/

#define	LEON_ACTION_MMAP	0
#define LEON_ACTION_MUNMAP	1
#define LEON_ACTION_ERASE	2
#define LEON_ACTION_COPY	3
#define LEON_ACTION_MPROTECT	4
#define LEON_ACTION_SIMPLECOPY	5
#define LEON_ACTION_HEAP	6
	
#define TARGET_SIZE		24
#define TARGET_OFFSET_ADDR	0
#define TARGET_OFFSET_ADDRL	TARGET_OFFSET_ADDR+4
#define TARGET_OFFSET_FLAGS	TARGET_OFFSET_ADDRL+4
#define TARGET_OFFSET_ACTION	TARGET_OFFSET_FLAGS+4
#define TARGET_OFFSET_ORIG	TARGET_OFFSET_ACTION+4
#define TARGET_OFFSET_ORIGL	TARGET_OFFSET_ORIG+4	

.global leon

leon:

popl    %eax /* eax => target */
popl	%ebx /* ebx => esp */
popl	%ecx /* ecx => entry point */	

push	%ebp
movl	%esp, %ebp

//call leon_getchar

movl	%eax, %esi

pushl	%eax
pushl	%ebx
pushl	%ecx
pushl	%esi

	
target_loop:
	
cmpl	$0, (%esi) /* The target.addr == 0 ?? this is the end */
je	target_end

//call leon_getchar

call 	leon_action

/* Next target */
addl	$TARGET_SIZE, %esi
jmp	target_loop
			
target_end:

/* Save the type of binary */
movl TARGET_OFFSET_ACTION(%esi), %edx

//call leon_getchar

popl	%esi
popl	%ecx
popl	%ebx
popl	%eax

movl	%ebp,%esp
popl	%ebp

/* Setup esp and entry point */
movl	%ebx, %esp
movl	%ecx, %eax

cmpl	$1, %edx
je 	leon_dyn

jmp 	leon_static
	
leon_dyn :

/* Setup zero the useless registers */
xorl    %ebx,%ebx
xorl   	%ecx,%ecx
xorl    %edx,%edx
xorl    %esi,%esi
xorl    %edi,%edi

/* rip of _start.S from libc */
xorl %ebp, %ebp
popl %esi               /* Pop the argument count.  */
movl %esp, %ecx         /* argv starts just at the current stack top.*/
andl $0xfffffff0, %esp
pushl %ecx              /* Push second argument: argv.  */
pushl %esi

/* Now we are all sons-of-bitches */
call	*%eax

/* but we can do the final job ! */
movl	$__NR_exit, %eax
movl	$0, %ecx
int	$0x80
	
leon_static :

/* Setup zero the useless registers */
xorl    %ebx,%ebx
xorl   	%ecx,%ecx
xorl    %edx,%edx
xorl    %esi,%esi
xorl    %edi,%edi

/* Now we are all sons-of-bitches */
jmp	*%eax

/* libc call exit !! */
	
/*************************************************************************************************/
/******************************************** LEON_ACTION ****************************************/
/*************************************************************************************************/

/* Action */
leon_action :
push	%ebp	
movl	%esp, %ebp

pushl	%edx
pushl	%ecx
pushl	%ebx
pushl	%eax
pushl	%esi
pushl	%edi
	
/* Switch to the right action */
movl	$LEON_ACTION_MMAP, %eax
cmpl	TARGET_OFFSET_ACTION(%esi), %eax
je 	leon_action_mmap

movl	$LEON_ACTION_MUNMAP, %eax
cmpl	TARGET_OFFSET_ACTION(%esi), %eax
je 	leon_action_munmap

movl	$LEON_ACTION_ERASE, %eax
cmpl	TARGET_OFFSET_ACTION(%esi), %eax
je 	leon_action_erase

movl	$LEON_ACTION_COPY, %eax
cmpl	TARGET_OFFSET_ACTION(%esi), %eax
je 	leon_action_copy

movl	$LEON_ACTION_MPROTECT, %eax
cmpl	TARGET_OFFSET_ACTION(%esi), %eax
je 	leon_action_mprotect

movl	$LEON_ACTION_SIMPLECOPY, %eax
cmpl	TARGET_OFFSET_ACTION(%esi), %eax
je 	leon_action_simplecopy

movl	$LEON_ACTION_HEAP, %eax
cmpl	TARGET_OFFSET_ACTION(%esi), %eax
je 	leon_action_heap
	
jmp	leon_action_fin

leon_action_mmap :
/* Allocate variables */
subl	$24,%esp	

/* start */
movl	TARGET_OFFSET_ADDR(%esi), %edx
movl	%edx, (%esp)
/* lenght */
movl	TARGET_OFFSET_ADDRL(%esi), %edx
movl	%edx, 4(%esp)

/* prot */
movl	TARGET_OFFSET_FLAGS(%esi), %edx
movl	%edx, 8(%esp)

/* flags */
movl	TARGET_OFFSET_ORIGL(%esi), %edx
movl	%edx, 12(%esp)

/* fd */
movl	$-1, 16(%esp)

/* offset */
movl	$0, 20(%esp)

/* Ebx must contains esp */
movl	%esp, %ebx

movl 	$__NR_mmap, %eax
int	$0x80
addl	$24,%esp	

/* The allocate address is in eax */
movl	%eax, %ebx
/* Now mprotect the section */
movl	$__NR_mprotect, %eax
movl	TARGET_OFFSET_ADDRL(%esi), %ecx
movl	TARGET_OFFSET_FLAGS(%esi), %edx
int	$0x80

jmp leon_action_fin

leon_action_munmap :
movl	TARGET_OFFSET_ADDR(%esi), %ebx
movl	TARGET_OFFSET_ADDRL(%esi), %ecx
movl	$__NR_munmap, %eax
int	$0x80
jmp	leon_action_fin	

leon_action_erase :
jmp leon_action_fin

leon_action_copy :
pushl	%esi

movl	$PROT_WRITE, %eax
andl	TARGET_OFFSET_FLAGS(%esi), %eax
cmpl	$0, %eax
jne	leon_action_copy_next

movl	$__NR_mprotect, %eax
movl	TARGET_OFFSET_ADDR(%esi), %ebx
movl	TARGET_OFFSET_ADDRL(%esi), %ecx
movl	$7, %edx
int	$0x80
	
leon_action_copy_next :
movl	%esi, %edx
movl	TARGET_OFFSET_ADDR(%edx),%edi
movl	TARGET_OFFSET_ORIG(%edx), %esi
movl	TARGET_OFFSET_ORIGL(%edx), %ecx
repz	movsb

popl	%esi

movl	$__NR_mprotect, %eax
movl	TARGET_OFFSET_ADDR(%esi), %ebx
movl	TARGET_OFFSET_ADDRL(%esi), %ecx
movl	TARGET_OFFSET_FLAGS(%esi), %edx
int	$0x80

jmp leon_action_fin

leon_action_mprotect :
movl	$__NR_mprotect, %eax
movl	TARGET_OFFSET_ADDR(%esi), %ebx
movl	TARGET_OFFSET_ADDRL(%esi), %ecx
movl	TARGET_OFFSET_FLAGS(%esi), %edx
int	$0x80
	
jmp leon_action_fin

leon_action_simplecopy :
movl	%esi, %edx
movl	TARGET_OFFSET_ADDR(%edx),%edi
movl	TARGET_OFFSET_ORIG(%edx), %esi
movl	TARGET_OFFSET_ORIGL(%edx), %ecx
repz	movsb

jmp leon_action_fin

leon_action_heap :
movl	TARGET_OFFSET_ORIG(%esi), %ebx
//andl    $0xfffff000, %ebx	
movl	$__NR_brk, %eax
int	$0x80

/*
pushl	%esi
pushl	%edi
pushl	%ebx
	
movl	TARGET_OFFSET_ADDR(%esi), %ebx
movl	TARGET_OFFSET_ADDRL(%esi), %ecx
movl	TARGET_OFFSET_ORIGL(%esi), %edx
movl	TARGET_OFFSET_ORIG(%esi), %edi
movl	TARGET_OFFSET_FLAGS(%esi), %esi
*/
	
/*
subl	$20,%esp	

movl	TARGET_OFFSET_ADDR(%esi), %edx
movl	%edx, (%esp)

movl	TARGET_OFFSET_ADDRL(%esi), %edx
movl	%edx, 4(%esp)

movl	TARGET_OFFSET_ORIGL(%esi), %edx
movl	%edx, 8(%esp)

movl	TARGET_OFFSET_FLAGS(%esi), %edx
movl	%edx, 12(%esp)

movl	TARGET_OFFSET_ORIG(%esi), %edx
movl	%edx, 16(%esp)
	
movl	%esp, %ebx
*/

//movl 	$__NR_mremap, %eax
//int	$0x80

//addl	$20,%esp	

/*
popl %ebx
popl %edi
popl %esi
*/
	
jmp leon_action_fin
	
leon_action_fin :

popl	%edi
popl	%esi	
popl	%eax
popl	%ebx
popl	%ecx
popl	%edx
	
movl	%ebp,%esp
popl	%ebp
	
ret


/*************************************************************************************************/
/******************************************** LEON_GETCHAR ***************************************/
/*************************************************************************************************/

/* Simple getchar */
leon_getchar:

/* Make the new stack */	
push	%ebp	
movl	%esp, %ebp

pushl	%edx
pushl	%ecx
pushl	%ebx
pushl	%eax

/* Only one local variable */
subl	$4, %esp

/* Set zero */
xorl	%eax, %eax
xorl	%ebx, %ebx
xorl	%ecx, %ecx
xorl	%edx, %edx

movl	$1, %edx
movl	%esp, %ecx
movl	$__NR_read, %eax	
int     $0x80

addl	$4, %esp

popl	%eax
popl	%ebx
popl	%ecx
popl	%edx
	
movl	%ebp,%esp
popl	%ebp
	
ret
		
.global leon_end
	
leon_end:

