#include <sys/ptrace.h>

#include "sanson.h"

int main(int argc, char *argv[])
{
  int pid;
  int i;
  char dest[atoi(argv[3])];
  unsigned long addr;

  pid = atoi(argv[1]);

  addr = strtoul(argv[2], NULL, 16);
  printf("pid %d @ 0x%lx strlen(%d)\n", pid, (unsigned long)addr, sizeof(dest));

  ptrace(PTRACE_ATTACH, pid, 0, 0);
  waitpid(pid, NULL, WUNTRACED);

  memset(dest, '\0', sizeof(dest));

  for (i=0; i<sizeof(dest); i++)
        dest[i]=(char)ptrace(PTRACE_PEEKTEXT, pid, addr+i, 0);

  sanson_hexdump((unsigned char *)(dest), sizeof(dest), (int)(dest));

  ptrace(PTRACE_DETACH, pid, 0, 0);

  return 0;
}
