#include "sanson.h"

/* rip from pitbull */
unsigned long sanson_locate_stack_bruteforce(void)
{
  unsigned long st_top;

  st_top = 0x0;
  
  /* locate stack top on this process */
  __asm__(
	  "   pusha\n"
	  "   jmp     .end_loop\n"
	  ".call_signal:\n"
	  "   popl    %%ecx\n"
	  "   xorl    %%ebx,%%ebx\n"
	  "   xorl    %%eax,%%eax\n"
	  "   movb    $11,%%bl\n"
	  "   movb    $48,%%al\n"
	  "   int     $0x80\n"
	  "   movl    %%esp,%%edi\n"
	  "   movl    %%edi,%%esi\n"
	  ".next:\n"
	  "   inc     %%edi\n"
	  "   movb    (%%edi),%%al\n"
	  "   jmp     .next\n"
	  ".end_loop:\n"
	  "   call    .call_signal\n"
	  "   movl    %%esi,%%esp\n"
	  "   movl    %%edi,%0\n"
	  "   popa\n"
	  : "=m"(st_top)
	  :
	  );
  return (st_top);  
}

unsigned long sanson_locate_stack(sanson_session_t *sst)
{
  unsigned long st_top;

  XCMP(sst, NULL, -1);

  st_top = 0x0;

  switch(sst->random)
    {
    case SANSON_RANDOM_NONE :
      sanson_debug("[%s:%s:%d] : LOCATE_STACK_NONE @",
                   __FILE__,
                   __FUNCTION__,
                   __LINE__);
      break;
    case SANSON_RANDOM_BRUTEFORCE :
      sanson_debug("[%s:%s:%d] : LOCATE_STACK_BRUTEFORCE @",
                   __FILE__,
                   __FUNCTION__,
                   __LINE__);

      st_top = sanson_locate_stack_bruteforce();
      break;
    case SANSON_RANDOM_PROCMAPS :
      sanson_debug("[%s:%s:%d] : LOCATE_STACK_PROCMAPS @",
                   __FILE__,
                   __FUNCTION__,
                   __LINE__);
      break;
    default :
      break;
    }

  sanson_debug(" 0x%lx\n", st_top);

  return st_top;
}

unsigned long find_name_stack(sanson_session_t *sst, unsigned long st_top)
{
  char buffer[sst->eat_stack];
  int i, j, k, check, match;
  unsigned long data, arg, verif, env, next;
  char c;
  char buffer2[8];

  memcpy(buffer, (unsigned long *)(st_top - sizeof(buffer)), sizeof(buffer));

  /* ok baby we don't have random */
  if (st_top == 0xc0000000)
    st_top--;

  for (i=sizeof(unsigned long); 
       i < sizeof(buffer); 
       i+=sizeof(unsigned long))
    {
      memcpy(&arg, &buffer[i-sizeof(arg)], sizeof(arg));
      memcpy(&data, &buffer[i], sizeof(arg));

      /* Check the first byte with st_top and arg */
      if (((0xffff0000 & data) == (0xffff0000 & st_top)) && (arg > 0 && arg <= 255))
	{
	  if (data < st_top)
	    memcpy(&c, (void *)data, sizeof(c));
      
	  /* If the first octet is not ascii, bye bye */
	  if (isascii(c))
	    {
	      /* Get the the null address */
	      memcpy(&verif, &buffer[i+arg*sizeof(unsigned long)], sizeof(unsigned long));
	      match = 0;

	      /* If it's not null, bye bye */
	      if (verif == 0x0)
		{
		  /* Get the address of the environment */
		  memcpy(&env, &buffer[i+(arg+1)*sizeof(unsigned long)], sizeof(unsigned long));

		  //printf("pouet 0x%lx %d verif 0x%lx env 0x%lx %d %d %c\n", data, arg, verif, env, match, check, c);

		  j = sizeof(unsigned long);
		  k = 0;
		  check = 0;
		  /* Check the structure */
		  while (k < arg && !match)
		    {
		      memcpy(&next, &buffer[i+j], sizeof(unsigned long));

		      // printf("NEXT 0x%lx\n", next);
		      if (next == 0x0)
			{
			  /* Zero argument => env is correct ? */
			  if (k < 1 && !((0xffff0000 & env) == (0xffff0000 & st_top)))
			    {
			      //printf("[1] pas match %d\n", k);
			      match = 1;
			    }
			}
		      else if (!((0xffff0000 & next) == (0xffff0000 & st_top)))
			{
			  //printf("[2] pas match %d\n", k);
			  match = 1;
			}
		      
		      /* Increments the argument verification */
		      if ((0xffff0000 & next) == (0xffff0000 & st_top))
			check++;
		      
		      j+=sizeof(unsigned long);
		      k++;
		    }
		  
		}
	      else 
		match = 1;
	      
	      /* Check == (arg - 1(null)) ?
		 data < st_top ?
		 match == 0 ?
		 ==> ok we found it !
	      */
	      if (match == 0 && data < st_top && (check == (arg - 1)))
		{
		  sanson_debug("FIN 0x%lx 0x%lx verif 0x%lx %d %d %c\n", 
			       data, arg, verif, match, check, c);
		  
		  memcpy(buffer2, (void *)data, sizeof(buffer2));
#if __DEBUG_SANSON__
		  sanson_hexdump((unsigned char *)buffer2, sizeof(buffer2), data);
#endif
		  return data;
		}

	      //printf("END\n");
	    }
	}
    }

  return 0x0;
}

unsigned long sanson_find_name(sanson_session_t *sst, unsigned long st_top)
{
  XCMP(sst, NULL, 0x0);

  switch(sst->find_name)
    {
    case SANSON_FIND_NAME_NONE :
      break;

    case SANSON_FIND_NAME_STACK :
      return find_name_stack(sst, st_top);
      break;
    }

  return 0x0;
}

int build_stack_static(sanson_session_t *sst,
		       sanson_execution_t *set,
		       sanson_arg_stack_t *sargv,
		       sanson_arg_stack_t *senv)
{
  unsigned long st_top, name_prog, addr;
  int argsize, tmp, i;
  void *esp;
  sanson_argv_t *tmpargv;
  sanson_argv_t *tmpargv_name;
  char *ptr_name;

  XCMP(sst, NULL, -1);
  XCMP(set, NULL, -1);
  XCMP(sargv, NULL, -1);
  XCMP(senv, NULL, -1);

  st_top = sanson_locate_stack(sst);

  set->st_top = st_top;

  if ((name_prog = sanson_find_name(sst, st_top)) != 0x0)
    {
      ptr_name = (char *)name_prog;
      i = 0;
      while(ptr_name[i] != '\0')
	{
	  i++;
	}

      tmpargv_name = sanson_alloc(sst, sizeof(sanson_argv_t));
      memset(tmpargv_name, '\0', sizeof(sanson_argv_t));
      memcpy(tmpargv_name->name, (char *)name_prog, i);
      sargv->size += i;
      sargv->argc++;
      TAILQ_INSERT_HEAD(&sargv->argv, tmpargv_name, entries);
    }

  argsize = sizeof(unsigned long); /* argc */

  argsize += sargv->argc * sizeof(unsigned long) + sizeof(unsigned long); /* Argc * sizeof(word) + NULL */

  argsize += senv->argc * sizeof(unsigned long) + sizeof(unsigned long); /* Envc * sizeof(word) + NULL */

  argsize += sargv->size + sargv->argc + sizeof(unsigned long);/* strlen(arg) + argc * '\0' + NULL */
  argsize += senv->size + senv->argc + sizeof(unsigned long);/* strlen(arg) + argc * '\0' + NULL */

  argsize += sizeof(unsigned long); /* stack top */

  sanson_debug("ARGSIZE %d\n", argsize);

  argsize = (argsize + 3) & ~3;

  sanson_debug("ARGSIZE %d\n", argsize);

  set->esp = (st_top - argsize);
  set->argsize = argsize;
  /* esp = address(stack_top) - strlen(new_stack) */
  esp = (void *)(st_top - argsize);

  sanson_debug("ST_TOP 0x%lx ESP 0x%lx\n", 
	       st_top, 
	       (unsigned long)esp);

  memset(esp, '\0', argsize);

  /* Addr = argv[] + NULL + env[] + NULL + argc */
  addr = 
    (unsigned long)esp + 
    ((sargv->argc + 1) * sizeof(unsigned long)) +
    ((senv->argc + 1) * sizeof(unsigned long)) +
    sizeof(unsigned long);

  sanson_debug("addr 0x%lx\n", addr);

  memcpy(esp, &sargv->argc, sizeof(int));
  esp = (void *)(esp+sizeof(int)); /* &argv[0] */

  /* Copy argv pointer + argv string */
  for (tmpargv = sargv->argv.tqh_first; 
       tmpargv != NULL; 
       tmpargv = tmpargv->entries.tqe_next)
    {
      strcpy((void *)addr, tmpargv->name);

      sanson_debug("ADDR ARGV 0x%lx\n", addr);
      memcpy(esp, &addr, sizeof(unsigned long));
      esp = (void *)(esp+sizeof(int));

      addr += strlen(tmpargv->name) + 1;
    }

  /* Copy NULL */
  tmp = 0;
  memcpy(esp, &tmp, sizeof(unsigned long));
  esp = (void *)(esp+sizeof(int));

  /* Copy env pointer + env strings */
  for (tmpargv = senv->argv.tqh_first; 
       tmpargv != NULL; 
       tmpargv = tmpargv->entries.tqe_next)
    {
      strcpy((void *)addr, tmpargv->name);

      sanson_debug("ADDR ENV 0x%lx\n", addr);
      memcpy(esp, &addr, sizeof(unsigned long));
      esp = (void *)(esp+sizeof(int));

      addr += strlen(tmpargv->name) + 1;
    }

  /* Copy NULL */
  tmp = 0;
  memcpy(esp, &tmp, sizeof(unsigned long));
  esp = (void *)(esp+sizeof(int));

  sanson_debug("DUMP STACK\n");
#if __DEBUG_SANSON__
  sanson_hexdump((void *)st_top-(argsize), (argsize), st_top-(argsize));
#endif

  return 0;
}
