#include <stdio.h>
#include <sys/types.h>
#include <dirent.h>
#include <stdlib.h>
#include <string.h>

int cmd_ls(char *rep)
{
  DIR *dir;
  struct dirent *mydirent;

  dir = opendir(rep);
  if (dir == NULL)
    {
      perror("dir :");
      return -1;
    }

  while((mydirent = readdir(dir)) != NULL)
      printf("%s\n", mydirent->d_name);

  closedir(dir);

  return 0;
}

int cmd_cat(char *file)
{
  FILE *fd;
  char buffer[1024];

  fd = fopen(file, "r");
  while(fgets(buffer, sizeof(buffer), fd))
      printf("%s", buffer);
  fclose(fd);

  fprintf(stdout, "test\n");
  return 0;
}

int cmd_rm(char *file)
{
  unlink(file);
  return 0;
}

int cmd_id(void)
{
  printf("uid=%d gid=%d\n", getuid(), getgid());
  return 0;
}

int cmd_yourcommand(char *arg)
{

  return 0;
}

int main(int argc, char *argv[])
{
  char buffer[1024];

  memset(buffer, '\0', sizeof(buffer));
  memcpy(buffer, "CMD_DYN.SO", strlen("CMD_DYN.SO"));
  printf("%s\n", buffer);

  if (argc < 2)
    return -1;

  if (argc == 3 && !strcmp(argv[1], "ls"))
    cmd_ls(argv[2]);
  else if (argc == 3 && !strcmp(argv[1], "cat"))
    cmd_cat(argv[2]);
  else if (argc == 3 && !strcmp(argv[1], "rm"))
    cmd_rm(argv[2]);
  else if (argc == 2 && !strcmp(argv[1], "id"))
    cmd_id();
  else if (argc == 3 && !strcmp(argv[1], "yourcommand"))
    cmd_yourcommand(argv[2]);

  return(0);
}
