#include <stdio.h>
#include <sys/types.h>
#include <dirent.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

int main(int argc, char *argv[])
{
  int i, j, pid;
  char **myargv;

  if (argc < 2)
    exit(-1);

  myargv = malloc(sizeof(char *) * (argc+1));

  i = 1;
  j = 0;
  while (i < argc)
    {
      myargv[j] = malloc(strlen(argv[i])+2);
      memset(myargv[j], '\0', strlen(argv[i]));
      snprintf(myargv[j], strlen(argv[i])+1, "%s", argv[i]);

      i++;
      j++;
    }

  myargv[j] = NULL;
  pid = fork();
  switch(pid)
    {
    case 0 :
      execve(argv[1], myargv, NULL);
      break;
    case -1 :
      exit(-1);
    default :
      waitpid(pid, 0, 0);
    }
  
  i = 1;
  while (i < argc)
    {
      free(myargv[i]);
      i++;
    }
      
  exit(0);
}
