#include  "sanson.h"
#include <sys/types.h>
#include <dirent.h>

#define NAME_DYN "./toto_dyn.so"

int main(int argc, char *argv[])
{
  sanson_session_t test;
  sanson_inject_t sit;
  sanson_paquet_t *spt;

  if (argc < 2)
    return -1;

  sanson_session_init(&test);

  sit.pid = atoi(argv[1]);

  if (sanson_make_paquet_binary(&test,
				NAME_DYN, 
				SANSON_COMPRESS_NONE, 
				SANSON_CRYPT_NONE) < 0)
    {
      fprintf(stdout, "Make error\n");
      return 0;
    }

  if (sanson_session_paquet_name_view(&test, NAME_DYN) < 0)
    {
      fprintf(stdout, "View error\n");
      return 0;
    }

  fprintf(stdout, "\n\nINJECT ET_DYN:\n\n");
  spt = sanson_session_paquet_name_get(&test, NAME_DYN);
  sanson_inject(&test, spt, &sit);

  return 0;
}
