#include  "sanson.h"

#define NAME_STATIC "./toto_static"

int main(int argc, char *argv[])
{
  sanson_arg_stack_t sargv, senv;
  sanson_session_t test;
  sanson_paquet_t *spt;
  sanson_argv_t *tmpargv;

  sanson_session_init(&test);
  TAILQ_INIT(&sargv.argv);
  TAILQ_INIT(&senv.argv);

  
  if (sanson_make_paquet_binary(&test,
				NAME_STATIC, 
				SANSON_COMPRESS_NONE, 
				SANSON_CRYPT_AES) < 0)
    {
      fprintf(stdout, "Make error\n");
      return 0;
    }

  if (sanson_session_paquet_name_view(&test, NAME_STATIC) < 0)
    {
      fprintf(stdout, "View error\n");
      return 0;
    }

  sargv.size = 0;
  sargv.argc = 0;

  tmpargv = sanson_alloc(&test, sizeof(sanson_argv_t));
  memset(tmpargv, '\0', sizeof(sanson_argv_t));
  memcpy(tmpargv->name, "-i", 2);
  sargv.size += 2;
  sargv.argc++;
  TAILQ_INSERT_TAIL(&sargv.argv, tmpargv, entries);

  senv.size = 0;
  senv.argc = 0;

  fprintf(stdout, "\n\nUL_EXEC STATIC :\n\n");
  spt = sanson_session_paquet_name_get(&test, NAME_STATIC);
  sanson_userland_execve(&test, spt, &sargv, &senv);

  return 0;
}
