#include  "sanson.h"

int main(int argc, char *argv[])
{
  sanson_arg_stack_t sargv, senv;
  sanson_session_t test;
  sanson_paquet_t *spt;
  sanson_argv_t *tmpargv;
  char *tok, *s1;

  sanson_session_init(&test);
  TAILQ_INIT(&sargv.argv);
  TAILQ_INIT(&senv.argv);

  if (sanson_make_paquet_binary(&test,
				argv[1], 
				SANSON_COMPRESS_NONE, 
				SANSON_CRYPT_AES) < 0)
    {
      fprintf(stdout, "Make error\n");
      return 0;
    }


  if (sanson_session_paquet_name_view(&test, argv[1]) < 0)
    {
      fprintf(stdout, "View error\n");
      return 0;
    }

  sargv.size = 0;
  sargv.argc = 0;

  if (argv[2] != NULL)
    {
      for (tok = sanson_strtok_r(argv[2], ";", &s1); tok; tok = sanson_strtok_r(NULL, ";", &s1))
	{
	  tmpargv = sanson_alloc(&test, sizeof(sanson_argv_t));
	  memset(tmpargv, '\0', sizeof(sanson_argv_t));
	  memcpy(tmpargv->name, tok, strlen(tok));
	  sargv.size += strlen(tok);
	  sargv.argc++;
	  TAILQ_INSERT_TAIL(&sargv.argv, tmpargv, entries);
	}
    }

  senv.size = 0;
  senv.argc = 0;
 
   if (argv[3] != NULL)
    {
      for (tok = sanson_strtok_r(argv[3], ";", &s1); tok; tok = sanson_strtok_r(NULL, ";", &s1))
	{
	  tmpargv = sanson_alloc(&test, sizeof(sanson_argv_t));
	  memset(tmpargv, '\0', sizeof(sanson_argv_t));
	  memcpy(tmpargv->name, tok, strlen(tok));
	  senv.size += strlen(tok);
	  senv.argc++;
	  TAILQ_INSERT_TAIL(&senv.argv, tmpargv, entries);
	}
    }

  fprintf(stdout, "\n\nUL_EXEC STATIC :\n\n");
  spt = sanson_session_paquet_name_get(&test, argv[1]);

  if (argv[argc-1] != NULL)
    if (!strcmp(argv[argc-1], "-nm"))
	test.find_name = SANSON_FIND_NAME_NONE;

  sanson_userland_execve(&test, spt, &sargv, &senv);

  return 0;
}
