#include "sanson.h"

int userland_execve_paquet_static(sanson_session_t *sst,
				  sanson_paquet_t *spt,
				  sanson_arg_stack_t *sargv,
				  sanson_arg_stack_t *senv,
				  sanson_execution_t *set)
{
  Elf32_Ehdr *e = (Elf32_Ehdr *) spt->binary;
 
  XCMP(sst, NULL, -1);
  XCMP(spt, NULL, -1);
  XCMP(sargv, NULL, -1);
  XCMP(senv, NULL, -1);
  XCMP(set, NULL, -1);

  sanson_debug("EXECVE PAQUET STATIC\n");

  build_stack_static(sst, set, sargv, senv);

  set->entry = e->e_entry;

  sanson_debug("[%s:%s:%d] : Construct virtual target\n",
	       __FILE__,
	       __FUNCTION__,
	       __LINE__);


  /* Recupere .text et .data */
  sanson_ul_maps_down(sst, set);

  sanson_ul_make_vt(sst, spt, set);

#if __DEBUG_SANSON__
  /* Visualisation des targets */
  view_virtual_target(&set->vtt);
#endif

  return 0;
}
